<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfJP_AdditionalPoliciesGroup ArrayType
 * @subpackage Arrays
 */
class ArrayOfJP_AdditionalPoliciesGroup extends AbstractStructArrayBase
{
    /**
     * The AdditionalPoliciesGroup
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\JP_AdditionalPoliciesGroup[]
     */
    public $AdditionalPoliciesGroup;
    /**
     * Constructor method for ArrayOfJP_AdditionalPoliciesGroup
     * @uses ArrayOfJP_AdditionalPoliciesGroup::setAdditionalPoliciesGroup()
     * @param \StructType\JP_AdditionalPoliciesGroup[] $additionalPoliciesGroup
     */
    public function __construct(array $additionalPoliciesGroup = array())
    {
        $this
            ->setAdditionalPoliciesGroup($additionalPoliciesGroup);
    }
    /**
     * Get AdditionalPoliciesGroup value
     * @return \StructType\JP_AdditionalPoliciesGroup[]|null
     */
    public function getAdditionalPoliciesGroup()
    {
        return $this->AdditionalPoliciesGroup;
    }
    /**
     * This method is responsible for validating the values passed to the setAdditionalPoliciesGroup method
     * This method is willingly generated in order to preserve the one-line inline validation within the setAdditionalPoliciesGroup method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateAdditionalPoliciesGroupForArrayConstraintsFromSetAdditionalPoliciesGroup(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfJP_AdditionalPoliciesGroupAdditionalPoliciesGroupItem) {
            // validation for constraint: itemType
            if (!$arrayOfJP_AdditionalPoliciesGroupAdditionalPoliciesGroupItem instanceof \StructType\JP_AdditionalPoliciesGroup) {
                $invalidValues[] = is_object($arrayOfJP_AdditionalPoliciesGroupAdditionalPoliciesGroupItem) ? get_class($arrayOfJP_AdditionalPoliciesGroupAdditionalPoliciesGroupItem) : sprintf('%s(%s)', gettype($arrayOfJP_AdditionalPoliciesGroupAdditionalPoliciesGroupItem), var_export($arrayOfJP_AdditionalPoliciesGroupAdditionalPoliciesGroupItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The AdditionalPoliciesGroup property can only contain items of type \StructType\JP_AdditionalPoliciesGroup, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set AdditionalPoliciesGroup value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_AdditionalPoliciesGroup[] $additionalPoliciesGroup
     * @return \ArrayType\ArrayOfJP_AdditionalPoliciesGroup
     */
    public function setAdditionalPoliciesGroup(array $additionalPoliciesGroup = array())
    {
        // validation for constraint: array
        if ('' !== ($additionalPoliciesGroupArrayErrorMessage = self::validateAdditionalPoliciesGroupForArrayConstraintsFromSetAdditionalPoliciesGroup($additionalPoliciesGroup))) {
            throw new \InvalidArgumentException($additionalPoliciesGroupArrayErrorMessage, __LINE__);
        }
        $this->AdditionalPoliciesGroup = $additionalPoliciesGroup;
        return $this;
    }
    /**
     * Add item to AdditionalPoliciesGroup value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_AdditionalPoliciesGroup $item
     * @return \ArrayType\ArrayOfJP_AdditionalPoliciesGroup
     */
    public function addToAdditionalPoliciesGroup(\StructType\JP_AdditionalPoliciesGroup $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\JP_AdditionalPoliciesGroup) {
            throw new \InvalidArgumentException(sprintf('The AdditionalPoliciesGroup property can only contain items of type \StructType\JP_AdditionalPoliciesGroup, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->AdditionalPoliciesGroup[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\JP_AdditionalPoliciesGroup|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\JP_AdditionalPoliciesGroup|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\JP_AdditionalPoliciesGroup|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\JP_AdditionalPoliciesGroup|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\JP_AdditionalPoliciesGroup|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string AdditionalPoliciesGroup
     */
    public function getAttributeName()
    {
        return 'AdditionalPoliciesGroup';
    }
}
